/* 
 * $Id: memedit.c 55 2005-06-07 12:17:07Z bsp $
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

extern int errno;
extern int yyparse();

#include "config.h"
#include "memedit_parser.h"
    
int debug = 0;
int mmaped_access = 0;
FILE *rl_instream;
int fd = -1;

void *mem = NULL;

int main (int argc, char *argv[])
{
	struct arg_t *kom_arg;

	kom_arg = Cmdline (argc, argv);

	printf("\nmemedit - quick change of memory content\n");
	printf("Copyright (C) 2004, 2005 by Pengutronix\n");
	printf("Please enter 'help' for a list of commands. \n\n");
	
	if (kom_arg->v)
	{
		printf ("%s: version %s\n", argv[0], PACKAGE_VERSION);
		return EXIT_FAILURE;
	}
	
	debug = kom_arg->V; 

	if (kom_arg->s)
	{
		rl_instream = fopen(kom_arg->s,"r");
		if(rl_instream) {
			printf("parsing %s\n",kom_arg->s);
			yyparse ();
		} else {
			printf ("opening \"%s\" failed\n%s\n", 
				   kom_arg->s, strerror(errno));
		}
	}

	if (kom_arg->optind) 
	{
		if(fd > 0) {
			printf("file already opened - ignoring command line\n");
		} else {
			fd = open(argv[kom_arg->optind], O_RDWR | O_SYNC);
			if (fd<0)
				printf ("opening \"%s\" failed\n%s\n", 
					   argv[kom_arg->optind], strerror(errno));
		}
	}

	rl_instream = stdin;
	yyparse ();
	
	return EXIT_SUCCESS;
}

void yyerror (const char *s)  /* Called by yyparse on error */
{
	printf ("%s\n", s);
}
